
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int dx[4] = {0,0,1,-1};
int dy[4] = {1,-1,0,0};


void load(int n, pair<int,int> &start_pos, vector<vector<int> > &field){
	field.clear();
	field.resize(n, vector<int>(n));
	string s;
	for(int i=0; i<n;i++){
		for(int j=0;j<n;j++){
			cin >> s;
			if(s == "X"){
				start_pos = make_pair(i,j);
				field[i][j] = 0;
			}else{
				field[i][j] = atoi(s.c_str());
			}
		}
	}
}
int least_dist(vector<vector<int> > &field1,vector<vector<int> > &field2){
	int n = field1.size();
	vector<pair<int,int> > idx2pos(n*n);
	for(int i=0;i<n;i++)
		for(int j=0;j<n;j++)
			idx2pos[field1[i][j]] = make_pair(i,j);
	int score = 0;
	for(int i=0;i<n;i++)
		for(int j=0;j<n;j++){
			pair<int,int> p = idx2pos[field2[i][j]];
			score += abs(p.first - i) + abs(p.second -j);
		}
	return (score+1)>>1;
}

int main(void){
	while(true){
		string dummy;
		int n, max_step;
		cin >> dummy >> n >> max_step;
		if(!cin) break;
		vector<vector<int> > start_field, goal_field;
		pair<int,int> start_pos, goal_pos;
		load(n, start_pos, start_field);
		load(n, goal_pos,  goal_field);
		cin >> dummy;
		bool ok = false;
		int ans = 0;
		if(start_field == goal_field)
			ok = true;
		vector<pair<pair<int,int>, vector<vector<int> > > > cur, next;
		next.push_back(make_pair(start_pos, start_field));
		for(int turn=0;turn<max_step;turn++){
			if(ok) break;
			cur.swap(next);
			next.clear();
			for(int i=0;i<cur.size(); i++){
				int x = cur[i].first.second;
				int y = cur[i].first.first;
				vector<vector<int> > &field = cur[i].second;
				for(int w=0;w<4;w++){
					int nx = x + dx[w];
					int ny = y + dy[w];
					if(nx < 0 || ny < 0 || nx >= n || ny >= n) continue;
					swap(field[y][x],field[ny][nx]);
					int d = least_dist(field, goal_field);
					if( d == 0){
						ans = turn + 1;
						ok = true;
						break;
					}
					if(turn + 1 + d <= max_step)
						next.push_back(make_pair(make_pair(ny,nx),field));
					swap(field[y][x],field[ny][nx]);
				}
				if(ok) break;
			}
			if(ok) break;
		}
		if(ok){
			cout << "SOLVABLE WITHIN "<<ans<<" MOVES" << endl << endl;
		}else{
			cout << "NOT SOLVABLE WITHIN "<<max_step<<" MOVES" << endl << endl;
		}
	}
	return 0;
}
